SystemOrganization addCategory: #SyncRepo!

Object subclass: #RepoAndFiles
	instanceVariableNames: 'repo files'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SyncRepo'!

!RepoAndFiles methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2012 10:43'!
copyFilesTo: subo2 withoutCommons: inter.

	(self files copyWithoutAll: inter) do: [:each| subo2 repo storeVersion: (self repo loadVersionFromFileNamed: each) ].! !

!RepoAndFiles methodsFor: 'accessing' stamp: 'hjo 4/15/2012 10:24'!
files
	^ files! !

!RepoAndFiles methodsFor: 'accessing' stamp: 'hjo 4/15/2012 10:24'!
files: anObject
	files := anObject! !

!RepoAndFiles methodsFor: 'accessing' stamp: 'hjo 4/15/2012 10:24'!
repo
	^ repo! !

!RepoAndFiles methodsFor: 'accessing' stamp: 'hjo 4/15/2012 10:24'!
repo: anObject
	repo := anObject! !

!RepoAndFiles methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2012 10:56'!
updateFilesOfPackageNames: packageNames

	files := ((repo allFileNames select: [:each|  packageNames anySatisfy: [:str | each beginsWith: str,'-']  ]) asSet).! !

Object subclass: #SyncRepo
	instanceVariableNames: 'packageNames inter subo1 subo2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SyncRepo'!

!SyncRepo class methodsFor: 'instance creation' stamp: 'hjo 4/15/2012 10:57'!
repository: repo1 repository: repo2 packageNames: anArray

	^self new 
		repo1: repo1;
		repo2: repo2;
		packageNames: anArray;
		syncRepos.! !

!SyncRepo class methodsFor: 'instance creation' stamp: 'hjo 4/15/2012 10:57'!
repository: repo1 repository: repo2 stringOfPackageNames: aString

	^self new 
		repo1: repo1;
		repo2: repo2;
		packageNames: aString subStrings;
		syncRepos.! !

!SyncRepo class methodsFor: 'examples' stamp: 'hjo 4/15/2012 10:58'!
shareDevPacer

	self 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/programming/language/smalltalk/Squeak/package-daliotMade')) 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/DropBox/DevPacer')) stringOfPackageNames: 'Ani LazyRabbit DevPacer DevPacerPharo12 DevPacerPharo13'.! !

!SyncRepo class methodsFor: 'examples' stamp: 'hjo 4/15/2012 10:58'!
shareSourceCodeTourGuide

	self 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/programming/language/smalltalk/Squeak/package-daliotMade')) 
		repository: (MCDirectoryRepository new directory: (FileDirectory on: '/Users/daliot/DropBox/SourceCodeTourGuide')) stringOfPackageNames: 'Ani Daliot DrillDownMethodSearch LazyRabbit SortDescriptors SourceCodeTourGuide'.! !

!SyncRepo methodsFor: 'accessing' stamp: 'hjo 4/15/2012 10:56'!
packageNames: strings

	packageNames := strings.! !

!SyncRepo methodsFor: 'accessing' stamp: 'hjo 4/15/2012 11:00'!
repo1: anMCRepository
	subo1 := RepoAndFiles new.
	subo1 repo: anMCRepository
! !

!SyncRepo methodsFor: 'accessing' stamp: 'hjo 4/15/2012 11:00'!
repo2: anMCRepository
	subo2 := RepoAndFiles new.
	subo2 repo: anMCRepository
! !

!SyncRepo methodsFor: 'operation' stamp: 'hjo 4/15/2012 10:56'!
syncRepos

subo1 updateFilesOfPackageNames: packageNames.
subo2 updateFilesOfPackageNames: packageNames.

inter := subo2 files intersection: subo1 files.

subo1 copyFilesTo: subo2 withoutCommons: inter.
subo2 copyFilesTo: subo1 withoutCommons: inter.! !
